
#include "CreditManager.h"
#include "ConfigureManager.h"
#include "StringManager.h"

using namespace CloudResourceManager;
using namespace std;

IntSet CreditManager::userBlackList;


void CreditManager::AddUserToBlackList()
{
//TO DO: it must be synchronized
    userBlackList.insert(user.UserId);
}

void CreditManager::StartCreditCheck()
{
    userBlackList.clear();
}

bool CreditManager::CheckJob(int runtimeInSeconds)
{
    consumption += runtimeInSeconds;
    int hour = (consumption + 3599) / 3600;
    if (user.Credits < hour * hourRate)
    {
        userBlackList.insert(user.UserId);
        return false;
    }
    return true;
}

bool CreditManager::StartTaskCheck(const Tasks& myTask)
{
    if (mySqlHelper.GetUsersById(myTask.UserId, user))
    {
        if ((hourRate = GetJobHourRate(myTask)) != -1)
        {
            consumption = 0;
            return true;
        }
    }
    return false;
}

int CreditManager::GetJobHourRate(const Tasks& myTask)
{
    EC2_InstanceTypes instanceType;
    int result = -1; //default??
    if (mySqlHelper.GetEC2_InstanceTypesById(myTask.EC2InstanceTypeId, instanceType))
    {
        string priceTerm;
        if (myTask.SpotInstance)
        {
            priceTerm = instanceType.EC2TypeName + "-spot";
        }
        else
        {
            priceTerm = instanceType.EC2TypeName + "-demand";
        }
        string price = ConfigureManager::Get(instanceType.PlatformName, priceTerm);
        StringManager::string2int(price, result);
    }
    return result;
}

bool CreditManager::ReportJobFinished(int runtimeInSeconds)
{
    //int hourRate = getJobHourRate(myJob.Task);
    int hour = (runtimeInSeconds + 3599) / 3600;
    user.Credits -= hourRate * hour;
    if (mySqlHelper.UpdateUsers(user.UserId, user))
    {
        return user.Credits > 0;
    }
    return false;
}
