#ifndef JOBMANAGER_H_INCLUDED
#define JOBMANAGER_H_INCLUDED

#include "stdafx.h"


namespace CloudResourceManager
{
    class CondorJobContext
    {
    public:
        time_t startRunTime;
        time_t lastCheckTime;
        int status;
        CondorJobContext();
    };

    typedef std::map<std::string, CondorJobContext> CondorJobContextMap;
    typedef std::pair<std::string, CondorJobContext> StringCondorJobContextPair;

    class JobManager
    {
    private:
        //private static string CondorCheckingIntervalInSeconds = ConfigurationManager.AppSettings["CondorCheckingIntervalInSeconds"];
        //private static int NeedRefreshIntervalInSeconds = Int32.Parse(CondorCheckingIntervalInSeconds);
        //public static string pspath = ConfigurationManager.AppSettings["pspath"];// "H:\\s3operation\\";

        static CondorJobContextMap condorJobCache;

    public:

        static void ClearCondorJobFromCache(const std::string& condorJobId);

        static bool CheckCondorJob(const std::string& condorJobId, CondorJobContext& condorJobContext);

        static time_t GetCondorJobRuntime(const std::string& condorJobId);

        static int CondorStatus2JobStatus(const std::string& condorStatus);

        static int GetCondorJobStatus(const std::string& condorJobId);

    };
}

#endif // JOBMANAGER_H_INCLUDED
