
#include "TaskManager.h"
#include "EmailManager.h"
#define MYSQLPP_SSQLS_NO_STATICS
#include "RenderingMax.h"
#include "JobManager.h"
#include "InstanceManager.h"
#include "Blender_RenderManager.h"
#include "CreditManager.h"
#include "ConfigureManager.h"
#include "StringManager.h"

using namespace CloudResourceManager;
using namespace std;

string TaskManager::CreateInstanceImmediateAfterTaskSubmit;
int TaskManager::creditCheckingInterval;
string TaskManager::adminemail;
string TaskManager::reportemail;
bool TaskManager::bInitialized = false;
int TaskManager::checkingCounter= 0;


TaskManager::TaskManager()
{
    if (!bInitialized)
    {
        bInitialized = true;
        string interval = ConfigureManager::AppSettings("CreditCheckingInterval");
        StringManager::string2int(interval, creditCheckingInterval);
        CreateInstanceImmediateAfterTaskSubmit = ConfigureManager::AppSettings("CreateInstanceImmediateAfterTaskSubmit");
        reportemail = ConfigureManager::AppSettings("ReportEMail");
        if (reportemail.size() == 0)
        {
            reportemail = "nickhuang99@hotmail.com";
        }
        adminemail = ConfigureManager::AppSettings("AdminEMail");
        if (adminemail.size() == 0)
        {
            adminemail = "nickhuang99@gmail.com";
        }
    }
}

void TaskManager::Check_New_Task()
{
    try
    {
        //1. find new tasks
        MySqlppHelper mySqlHelper;
        vector<Tasks> myNewTasks = mySqlHelper.GetNewTasks();
        for (int i = 0; i < myNewTasks.size(); i ++)
        {
            //ConfigLogger.Instance.LogInfo("a new task id:" + myTask.TaskId.ToString());
            Tasks& myTask = myNewTasks[i];
            //create the job to upload file to S3
            //ClusterMaxDAL.JobRepository myJobRepository = new ClusterMaxDAL.JobRepository();
            if (myTask.TaskTypeId ==(int)TaskTypeEnum::Blender_Rendering)
            {
                Blender_RenderManager myRender;
                if (myRender.InitiateTask(myTask.TaskId))
                {
                    myTask.TaskStatusId =(int)TaskStatusEnum::Initiate;
                    //myTaskRepository.Save();

                    // This must be "TRUE"
                    if (CreateInstanceImmediateAfterTaskSubmit.compare("true") == 0)
                    {
                        InstanceManager instanceManager;
                        instanceManager.ScaleInstancesByTask(myTask.TaskId);
                    }
                    mySqlHelper.UpdateTasks(myTask.TaskId, myTask);
                }
            }
        }
    }
    catch (runtime_error e)
    {
        //ConfigLogger.Instance.LogError("check_New_Task:" + e.Message.ToString()+"\r\n Helplink:"+e.HelpLink+"\r\n Source:"+e.Source +"\r\n StackTrace :"+e.StackTrace +"\r\n TargetSite:"+e.TargetSite);
        FILE_LOG(logERROR)<<"check_New_Task:" << e.what();
    }
}

void TaskManager::Check_Initiate_Task()
{
    //check the initiate tasks
    try
    {
        //Find initiate tasks
        //if the related initiated job is completed, then generate rendering jobs.
        //and change the task to the status "Start"
        MySqlppHelper mySqlHelper;
        vector<Tasks> myNewTasks = mySqlHelper.GetNewTasks();
        for (int i = 0; i < myNewTasks.size(); i ++)
        {
            //ConfigLogger.Instance.LogInfo("a new task id:" + myTask.TaskId.ToString());
            Tasks& myTask = myNewTasks[i];
            //create the job to upload file to S3
            //ClusterMaxDAL.JobRepository myJobRepository = new ClusterMaxDAL.JobRepository();
            if (myTask.TaskTypeId ==(int)TaskTypeEnum::Blender_Rendering)
            {
                Blender_RenderManager myRender;
                if (myRender.StartTask(myTask.TaskId))
                {
                    //ConfigLogger.Instance.LogStatus("start to generate render jobs.");
                    Blender_RenderManager myRender;
                    int iJobCount = myRender.GenerateRenderJobs(myTask);
                    //ConfigLogger.Instance.LogStatus("change the status of task to Start");
                    //ConfigLogger.Instance.LogStatus(myTask.TaskStatusId);
                    //change the status of task to "Start"
                    if (iJobCount > 0)
                    {
                        myTask.TaskStatusId = (int)TaskStatusEnum::Start;
                        //CloudResourceManager.InstanceManager myInstanceManager = new CloudResourceManager.InstanceManager();
                        // this must be "FALSE"!!!
                        if (CreateInstanceImmediateAfterTaskSubmit.compare("true") != 0) //not set true
                        {
                            InstanceManager instanceManager;
                            instanceManager.ScaleInstancesByTask(myTask.TaskId);
                        }
                        mySqlHelper.UpdateTasks(myTask.TaskId, myTask);
                    }
                    else
                    {
                        //ConfigLogger.Instance.LogStatus("Render jobs are empty.");
                        FILE_LOG(logINFO)<<"Render jobs are empty.";
                    }
                    //ConfigLogger.Instance.LogStatus("changeed the status of task as Start");
                    FILE_LOG(logINFO)<<"changeed the status of task as Start";
                    //check the instances number of the task, add new instance if the resource is available
                }
                else
                {
                    //ConfigLogger.Instance.LogStatus("Cannot start Task :"+myTask.TaskId.ToString());
                    FILE_LOG(logERROR)<< "Cannot start Task :"<<myTask.TaskId;
                }
            }
            //myTaskRepository.Save();
        }
    }
    catch (runtime_error e)
    {

        //ConfigLogger.Instance.LogError("check_Initiate_Task:" + "Message:" + e.Message.ToString() + "\r\n Helplink:" + e.HelpLink + "\r\n Source:" + e.Source + "\r\n StackTrace :" + e.StackTrace + "\r\n TargetSite:" + e.TargetSite);
        FILE_LOG(logERROR)<<"check_Initiate_Task:"<< e.what();
    }
}


void TaskManager::Check_Started_Task()
{
    //check the started tasks
    //ConfigLogger.Instance.LogInfo("* Check the started tasks and run time.");
    try
    {
        if (checkingCounter % creditCheckingInterval == 0)
        {
            CreditManager::StartCreditCheck();
        }
        //load notification email address

        //Find started tasks
        MySqlppHelper mySqlHelper;
        vector<Tasks> myStartedTasks = mySqlHelper.GetStartTasks();

        for (int i = 0; i < myStartedTasks.size(); i ++)
        {
            Tasks& myTask = myStartedTasks[i];
            vector<Jobs> myJobs;
            CreditManager creditManager;
            //check the instances number of the task, add new instance if the resource is available
            //CloudResourceManager.InstanceManager myInstanceManager = new CloudResourceManager.InstanceManager();

            //myInstanceManager.ScaleInstancesByTask(myTask.TaskId);
            bool bTaskCompleted = true;
            //List<ClusterMaxDAL.Job> myJobs = null;
            //ConfigLogger.Instance.LogInfo("Check the job status.");
            FILE_LOG(logINFO)<<"Check the job status.";

            if (checkingCounter % creditCheckingInterval == 0)
            {
                creditManager.StartTaskCheck(myTask);
            }

            if (myTask.TaskTypeId == (int)TaskTypeEnum::Blender_Rendering)
            {
                myJobs = mySqlHelper.GetIncompleteJobsByTaskId(myTask.TaskId);
                for (int j = 0; j < myJobs.size(); j ++)
                {
                    Jobs& myJob = myJobs[j];

                    int currentJobStatus = myJob.JobStatusId;
                    int myJobStatus = JobManager::GetCondorJobStatus(myJob.CondorJobId);
                    //ConfigLogger.Instance.LogInfo("Find job status:" + myJobStatus.ToString() + " for job" + myJob.JobId.ToString());
                    FILE_LOG(logINFO)<<"Find job status:"<< myJobStatus<< " for job" << myJob.JobId;

                    if (myJobStatus != JobStatusEnum::Unknown)
                    {
                        //
                        if (myJobStatus != JobStatusEnum::Finish && myJobStatus != JobStatusEnum::Abort && myJobStatus != JobStatusEnum::Error )
                        {
                            bTaskCompleted = false;
                        }
                        myJob.JobStatusId = (int)myJobStatus;
                    }
                    else
                    {
                        bTaskCompleted = false;
                    }

                    // nick: This is now a big bottle-neck!!!

                    //ConfigLogger.Instance.LogInfo("Check the job run time");
                    FILE_LOG(logINFO)<<"Check the job run time";

                    //string timeResult = ScriptManager.runScriptWrapper("condor_find_job_runtime.ps1", myJob.CondorJobId);
                    time_t timeResult = JobManager::GetCondorJobRuntime(myJob.CondorJobId);

                    if (timeResult != 0)
                    {
                        myJob.JobRunTime = timeResult;
                        //ConfigLogger.Instance.LogInfo("Get Condor Job:" + myJob.CondorJobId + " runtime-" + jobruntime.ToString());
                        FILE_LOG(logINFO)<<"Get Condor Job:" << myJob.CondorJobId << " runtime " <<timeResult;
                    }

                    //send a notification for the completed job
                    if (currentJobStatus != JobStatusEnum::Finish && myJobStatus == JobStatusEnum::Finish)
                    {
                        //ConfigLogger.Instance.LogInfo("Send an email for job:" + myJob.CondorJobId);
                        FILE_LOG(logINFO)<<"Send an email for job:" << myJob.CondorJobId;
                        if (myTask.NotificationTypeId == NotificationTypeEnum::Email)
                        {
                            //Utilities.SendEmail(reportemail, null, "Job:" + myJob.JobId.ToString() + " is comleted.", "this is an email notification. You can download the output of this job at:'" + myJob.JobOutputMainFile + "'", true, "maxrendering@gmail.com", "maxrendering");
                            //Utilities.SendEmail(adminemail, null, "Job:" + myJob.JobId.ToString() + " is comleted.", "this is an email notification. You can download the output of this job at:'" + myJob.JobOutputMainFile + "'", true, "maxrendering@gmail.com", "maxrendering");
                            EmailManager email;
                            string subject = "Job:" + StringManager::int2string(myJob.JobId) + " is comleted.";
                            string msg = "this is an email notification. You can download the output of this job at:" + myJob.JobOutputMainFile;
                            email.SendReportMail(reportemail, subject, msg);
                            email.SendReportMail(adminemail, subject, msg);
                        }
                        creditManager.ReportJobFinished(myJob.JobRunTime);
                    }
                    if (currentJobStatus != JobStatusEnum::Finish && myJobStatus != JobStatusEnum::Finish)
                    {
                        if (checkingCounter % creditCheckingInterval == 0)
                        {
                            creditManager.CheckJob(myJob.JobRunTime);
                        }
                    }
                    mySqlHelper.UpdateJobs(myJob.JobId, myJob);
                }
            }

            if (bTaskCompleted)
            {
                myTask.TaskStatusId = (int)TaskStatusEnum::Finish;

                mySqlHelper.UpdateTasks(myTask.TaskId, myTask);

                if (myTask.NotificationTypeId == 1)
                {
                    //Utilities.SendEmail(reportemail, null, "Task:" + myTask.TaskId.ToString() + " is comleted.", "this is an email notification.", true, "maxrendering@gmail.com", "maxrendering");
                    //Utilities.SendEmail(adminemail, null, "Task:" + myTask.TaskId.ToString() + " is comleted.", "this is an email notification.", true, "maxrendering@gmail.com", "maxrendering");
                    EmailManager email;
                    string subject = "Task:" + StringManager::int2string(myTask.TaskId) + " is comleted.";
                    string msg = "this is an email notification.";
                    email.SendReportMail(reportemail, subject, msg);
                    email.SendReportMail(adminemail, subject, msg);
                }
                //ConfigLogger.Instance.LogInfo("Send an email for task:" + myTask.TaskId.ToString());
                FILE_LOG(logINFO)<<"Send an email for task:"<<myTask.TaskId;
                // clear cache
                for(int i = 0; i< myJobs.size(); i ++)
                {
                    JobManager::ClearCondorJobFromCache(myJobs[i].CondorJobId);
                }
            }
        }
        //myJobRepository.ForceSave();
        //myTaskRepository.ForceSave();
    }
    catch (runtime_error e)
    {
        //ConfigLogger.Instance.LogError("check_Started_Task:" + "Message:" + e.Message.ToString() + "\r\n Helplink:" + e.HelpLink + "\r\n Source:" + e.Source + "\r\n StackTrace :" + e.StackTrace + "\r\n TargetSite:" + e.TargetSite);
        FILE_LOG(logERROR)<<"Check_Started_Task:"<<e.what();
    }
}

void TaskManager::CheckStatus()
{
    //ConfigLogger.Instance.LogStatus("start to check new task");
    FILE_LOG(logSTATUS)<<"start to check new task";
    Check_New_Task();
    //ConfigLogger.Instance.LogStatus("start to check initiated task");
    FILE_LOG(logSTATUS)<<"start to check initiated task";
    Check_Initiate_Task();

    //ConfigLogger.Instance.LogStatus("start to check Started task");
    FILE_LOG(logSTATUS)<<"start to check Started task";

    Check_Started_Task();

    //ConfigLogger.Instance.LogStatus("Finish to check tasks");
    FILE_LOG(logSTATUS)<<"Finish to check tasks";
    checkingCounter++;
}


