// This may look like C code, but it's really -*- C++ -*-
/*
 * Copyright (C) 2008 Emweb bvba
 *
 * See the LICENSE file for terms of use.
 */

#ifndef BASIC_CONTROLS_H_
#define BASIC_CONTROLS_H_

#include <Wt/WMenu>
#include <Wt/WTabWidget>
#include <Wt/WContainerWidget>
#include <Wt/Ext/TabWidget>
#include <vector>

using namespace Wt;

typedef std::pair<std::string, WWidget*> WidgetNamePair;
typedef std::vector<WidgetNamePair> WidgetNamePairVector;

class BasicControls : public  WContainerWidget
{
public:
    BasicControls(WContainerWidget *parent = 0);
    void createWidgetNameVector(WidgetNamePairVector& widgetNameVector);
private:
    Wt::WWidget *wText();
    Wt::WWidget *wTemplate();
    Wt::WWidget *wBreak();
    Wt::WWidget *wAnchor();
    Wt::WWidget *wImage();
    Wt::WWidget *wTable();
    Wt::WWidget *wTree();
    Wt::WWidget *wTreeTable();
    Wt::WWidget *wPanel();
    Wt::WWidget *wTabWidget();
    Wt::WWidget *wContainerWidget();
    Wt::WWidget *wMenu();
    Wt::WWidget *wGroupBox();
    Wt::WWidget *wStackedWidget();
    Wt::WWidget *wProgressBar();
    void populateSubMenu(Wt::WMenu *menu);
    void topic(const std::string &classname, WContainerWidget *parent) const;
    void topic(const std::string &classname1,
               const std::string &classname2,
               WContainerWidget *parent) const;
    void topic(const std::string &classname1,
               const std::string &classname2,
               const std::string &classname3,
               WContainerWidget *parent) const;
    void topic(const std::string &classname1,
               const std::string &classname2,
               const std::string &classname3,
               const std::string &classname4,
               WContainerWidget *parent) const;
    std::string docAnchor(const std::string &classname) const;
    std::string title(const std::string &classname) const;
    std::string escape(const std::string &name) const;
};

#endif // BASIC_CONTROLS_H_
