/* this is a -*-C++-*- file
 * Copyright (C) 2005 Wim Dumon
 *
 * See the LICENSE file for terms of use.
 */

#ifndef LOGINWIDGET_H_
#define LOGINWIDGET_H_

#include <Wt/WContainerWidget>
#include <Wt/WSignal>
#include <Wt/WJavaScript>
#include <Wt/WPushButton>
#include <Wt/MD5PasswordEdit.h>
#include "NotifyEvent.h"

namespace Wt
{
    class WLineEdit;
    class WText;
    class WComboBox;
}

using namespace Wt;


class LoginWidget : public WContainerWidget
{
public:
    //typedef bool (WObject::*ValidLoginMethod)(const std::string& user, const std::string& pass);
    typedef int (WObject::*ValidLoginMethod)(const std::string& user, const std::string& pass);
    LoginWidget(WContainerWidget *parent = 0);
    void setupValidLoginMethod(ValidLoginMethod validLoginMethod, WObject* loginObj);
    void setupNotifyEventMethod(NotifyMethod notifyMethod, WObject* notifyObj);
    void getUserName(std::string& userName) { userName = m_userName;}
    void getUserPass(std::string& userPass) { userPass = m_md5HexStr;}
    int  getUserId(){ return m_userId;}
private:
    std::string m_userName;
    std::string m_md5HexStr;
    int         m_userId;
    WText     *IntroText;
    WLineEdit *Username;
    MD5PasswordEdit *Password;
    WPushButton *LoginButton;
    ValidLoginMethod m_validMethod;
    WObject*   m_loginObj;
    NotifyMethod m_notifyMethod;
    WObject*   m_notifyObj;
    void checkCredentials(std::string passwordInMD5);
};

#endif
