#ifndef REGISTERWIDGET_H_INCLUDED
#define REGISTERWIDGET_H_INCLUDED

#include <Wt/WContainerWidget>

#include <Wt/WText>
#include <Wt/WLabel>
#include <Wt/WLineEdit>
#include <Wt/WPushButton>
#include <Wt/MD5PasswordEdit.h>
#include "NotifyEvent.h"

namespace Wt
{
    class WLineEdit;
    class WText;
    class WComboBox;
}

using namespace Wt;


class RegisterWidget : public WContainerWidget
{
public:
    //typedef bool (WObject::*ValidLoginMethod)(const std::string& user, const std::string& pass);
    typedef bool (WObject::*ValidRegisterMethod)(const std::string& user, const std::string& pass, const std::string& email);
    RegisterWidget(WContainerWidget *parent = 0);

    void setupValidRegisterMethod(ValidRegisterMethod validRegisterMethod, WObject* registerObj);
    void setupNotifyEventMethod(NotifyMethod notifyMethod, WObject* notifyObj);
    void getUserInfo(std::string& userName, std::string& userPass, std::string& userMail);
private:
    std::string m_userName;
    std::string m_userPass;
    std::string m_userMail;
    WText     *IntroText;
    WText     *ReasonText;
    WText     *UserText;
    WText     *PasswordText;
    WText     *RepeatPasswordText;
    WLineEdit *Username;
    MD5PasswordEdit *Password;
    MD5PasswordEdit *RepeatPassword;
    WText     *EmailText;
    WLineEdit *Email;
    WPushButton *RegisterButton;
    ValidRegisterMethod m_validMethod;
    WObject*   m_registerObj;
    NotifyMethod m_notifyMethod;
    WObject*   m_notifyObj;
    static char* UserMsg;
    static char* PasswordMsg;
    static char* RepeatPasswordMsg;
    static char* EmailMsg;
    bool bValidRepeat;
    void checkUser();
    void checkPass();
    void checkRepeat();
    void checkValid();
    void checkCredentials(std::string passwordInMD5);
    bool checkRegister();
};

#endif // REGISTERWIDGET_H_INCLUDED
